      Program fft2d
c     Programma dimostrativo della subroutine fft2 
 
      external fft2
      
      integer nmax
      parameter(nmax=32)
      
      integer n,ifail
      real x(nmax),y(nmax)
      complex f(nmax)
      character*12 fin,fout1,fout2

      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE FFT2 ***'
      print*
      write(*,20)'Ordine della trasformata (max ',nmax,')= '
      read(*,*)n
      print*
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n
         read(11,*)x(i)
    1 continue
      read(11,*)
      do 2 i=1,n
         read(11,*)y(i)
    2 continue 
      close(11)                  
c     Costruzione del vettore di numeri complessi      
      do 10 i=1,n
         f(i)=cmplx(x(i),y(i))
   10 continue

c     Trasformata       
      call fft2(1,f,n,ifail)

      if (ifail .eq. 20) stop 'Errore! ordine non valido'
      if (ifail .eq. 21) stop 'Errore! l''ordine non  potenza di due'
      
      print*
      print*,'Nome del file di output (DFT)= '
      read(*,'(A)')fout1
      open(12,FILE=fout1)
      write(12,'(2E14.7)')(f(i),i=1,n)
      close(12)

      print*,'Vettore trasformato= '
      write(*,30)(real(f(i)),aimag(f(i)),i=1,n)
                  
c     Antitrasformata
      call fft2(0,f,n,ifail)
      
      print*
      print*,'Nome del file di output (IDFT)= '
      read(*,'(A)')fout2
      open(13,FILE=fout2)
      write(13,'(2E14.7)')(f(i),i=1,n)
      close(13)

      print*,'Vettore antitrasformato='
      write(*,30)(real(f(i)),aimag(f(i)),i=1,n)
                  
   20 format(1X,A,I2,A)
   30 format(1X,'(',E13.7,',',E14.7,')')
      stop
      End
      
