      program nwtd
      
      external nwt
      
      integer dim,lung
      parameter (dim=9,lung=100)
      
      integer n,ifail
      real p(dim),a(dim),x(lung),y(lung)
      character*12 fin1,fin2,fin3,fout
      
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE NWTN ***'
      print*
      write(*,10)'Numero di punti di interpolazione (max',dim,')= '
      read(*,*)n
            
      print*,'Nome del file di input (punti di interpolazione)= '
      read(*,'(A)')fin1
      open(11,FILE=fin1,STATUS='OLD')
      do 1 i=1,n
         read(11,*)p(i)
    1 continue
      close(11)
      
      print*,'Nome del file di input (coefficienti del polinomio)= '
      read(*,'(A)')fin2
      open(12,FILE=fin2,STATUS='OLD')
      do 2 i=1,n
         read(12,*)a(i)
    2 continue
      close(12)
      
      write(*,10)'Numero di ascisse (max ',lung,')= '
      read(*,*)m
      
      print*,'Nome del file di input (ascisse)= '
      read(*,'(A)')fin3
      open(13,FILE=fin3,STATUS='OLD')
      do 3 i=1,m
         read(13,*)x(i)
    3 continue
      close(13) 
c
c	la chiamata originale e' quella commentata
 
       call nwt(p,a,n,x,m,y,ifail)      

c      call nwtn(p,a,n,x,m,y,ifail)
c      verificare qual'e' l'errore
c      
      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
            
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(14,FILE=fout)
      write(14,20)(y(i),i=1,m)
      close(14)                    
      
      print*,'Valori del polinomio: '
      write(*,20)(y(i),i=1,m)
         
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)   
   
      End
      stop