      Program pmq2d
c     Programma dimostrativo della subroutine pmq2.
      
      external pmq2
      
      integer dim
      parameter (dim=100)
      
      real x(dim),y(dim),r(dim),c(3)
      integer ifail
      character*12 fin,fout
            
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE PMQ2 ***'
      print*
      write(*,*)'Numero di nodi (max',dim,')= '
      read(*,*)n
      
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n
         read(11,*)x(i)
    1 continue
      do 2 i=1,n
         read(11,*)y(i)
    2 continue 
      close(11)
            
      call pmq2(x,y,n,c,r,ifail)
       
      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
      if (ifail .eq. 13) stop 'Errore! infinite soluzioni'
      if (ifail .eq. 14) print*,'Attenzione! algoritmo inadeguato'
            
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,'(E14.7)')(c(i),i=1,3)
      write(12,*)
      write(12,'(E14.7)') (r(i),i=1,n)
      close(12)
      
      write(*,10)'Coefficiente del termine di grado 0: ',c(1)
      write(*,10)'Coefficiente del termine di grado 1: ',c(2)
      write(*,10)'Coefficiente del termine di grado 2: ',c(3)
            
      print*,'Residuo= '
      write(*,'(E14.7)')(r(i),i=1,n)
               
   10 format (1X,A,E14.7)
   
      End