      Program splind
c     Programma dimostrativo della subroutine splin

      external splin
      
      integer dim1,dim2
      parameter (dim1=20,dim2=50)
      
      real p(dim1)
      real a(dim1-1),b(dim1-1),c(dim1-1),d(dim1-1)
      real x(dim2),y(dim2)
      integer n,m,ifail,log
      character*12 fin1,fin2,fin3,fout
      
      log=20
      open(log,FILE='spl.log')
            
      print*                 
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE SPLIN ***'
      print*
      write(*,20)'Numero di punti di interpolazione (max',dim1,')= '
      read(*,*)n
      print*,'Nome del file di input (punti di interpolazione)= '
      read(*,'(A)')fin1
      open(11,FILE=fin1,STATUS='OLD')
      
      write(log,*)'punti di interpolazione'
      
      do 1 i=1,n
         read(11,*)p(i)
         write(log,*)p(i)
    1 continue
      close(11)
      
      write(log,*)'coefficienti della spline a, b, c, d'
      
      print*,'Nome del file di input (coefficienti della spline)= '
      read(*,'(A)')fin2
      open(12,FILE=fin2,STATUS='OLD')
      do 2 i=1,n-1
         read(12,*)a(i)
         write(log,*)a(i)
    2 continue
      do 3 i=1,n-1
         read(12,*)b(i)
         write(log,*)b(i)
    3 continue
      do 4 i=1,n-1
         read(12,*)c(i)  
         write(log,*)c(i)
    4 continue
      do 5 i=1,n-1
         read(12,*)d(i)  
         write(log,*)d(i)
    5 continue
      close(12)
                      
      write(log,*)'pt. di tabellazione'                      
      write(*,20)'Numero di punti di tabellazione (max',dim2,')= '
      read(*,*)m
      print*,'Nome del file di input (dominio)= '
      read(*,'(A)')fin3
      open(13,FILE=fin3,STATUS='OLD')  
      do 6 i=1,m
         read(13,*)x(i)
         write(log,*)x(i)
    6 continue
      close(13)
                                            
      write(log,*)'chiamata splin'
                                                  
      call splin(p,a,b,c,d,n,m,x,y,ifail,log)
      
      write(log,*)'ritorno func chiamante'
      write(log,*)'ifail=',ifail
      
      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
      if (ifail .eq. 15) stop 'Errore! ascissa non valida'
      
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(14,FILE=fout)
      write(14,'(E14.7)')(y(i),i=1,m)
      write(log,'(E14.7)')(y(i) ,i=1,m)
      close(14)
      
      close(log)
      
      print*,'Tabellazione della spline :'
      write(*,30)'x=','y='
      write(*,40)(x(i),y(i),i=1,m)
      
      
            
   20 format (1X,A,I3,A)   
   30 format (1X,A2,14X,A2)
   40 format (1X,E15.7,E16.7)
      
      stop    
      End
      
