      Program conwtd
c     Programma dimostrativo della subroutine dfdv
 
      external conwt
      
      integer dim
      parameter (dim=10)
      
      integer n,ifail
      real x(dim),y(dim),a(dim)
      character*12 fin,fout

      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE CONWT ***'
      print*
      write(*,10)'Numero di punti di interpolazione (max ',dim,')= '
      read(*,*)n
      
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n
         read(11,*)x(i)
    1 continue      
      read(11,*)
      do 2 i=1,n
         read(11,*)y(i)
    2 continue
      close(11)

      call conwt(x,y,n,a,ifail)

      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
      if (ifail .eq. 12) stop 'Errore! ascisse coincidenti'
      
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,'(E14.7)')(a(i),i=1,n)
      close(12)

      print*,'Coefficienti del polinomio interpolante ='
      write(*,'(E14.7)')(a(i),i=1,n)
   
   10 format (1X,A,I3,A)
  
      end
      
      
                                              
         