      Program cospld
c     Programma dimostrativo della subroutine cospl

      external cospl
      
      integer dim
      parameter (dim=20)
      
      real x(dim),y(dim),a(dim-1),b(dim-1),c(dim-1),d(dim-1)
      integer n,ifail
      character*12 fin,fout
            
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE COSPL ***'
      print*
      write(*,10)'Numero di punti di interpolazione (max ',dim,')= '
      read(*,*)n
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n
         read(11,*)x(i)
    1 continue
      read(11,*)
      do 2 i=1,n
         read(11,*)y(i)
    2 continue
      close(11)
      
      call cospl(x,y,n,a,b,c,d,ifail)
      
      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
      if (ifail .eq. 12) stop 'Errore! ascisse coincidenti'
      
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,'(E14.7)')(a(i),i=1,n-1)
      write(12,*)
      write(12,'(E14.7)')(b(i),i=1,n-1)
      write(12,*)
      write(12,'(E14.7)')(c(i),i=1,n-1)
      write(12,*)
      write(12,'(E14.7)')(d(i),i=1,n-1)
      close(12)                                        
      
      print*,'Coefficienti della spline= '
      write(*,30)'a=','b=','c=','d='
      write(*,20)(a(i),b(i),c(i),d(i),i=1,n-1)
      
   10 format (1X,A,I3,A)   
   20 format (1X,E15.7,E16.7,E16.7,E16.7)
   30 format (1X,A2,14X,A2,14X,A2,14X,A2)
          
      End
      stop