      Program lubd
c     Programma dimostrativo della subroutine lubd

      external lub
      
      integer dim,maxp,maxq
      parameter (dim=10, maxp=4, maxq=4)
       
      real a(dim,maxp+maxq+1)                    
      integer n,ifail,amp,p,q,log
      character*12 fin,fout
                             
      log=13
      open(log,FILE='lub.log')                             
      
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE LUB ***'
      print*
      write(*,10)'Ordine della matrice (max ',dim,') = '
      read(*,*)n       
      write(*,10)'Ampiezza di banda inferiore (max ',maxp,') = '
      read(*,*)p
      write(*,10)'Ampiezza di banda superiore (max ',maxq,') = '
      read(*,*)q       
      amp=p+q+1
      print*,'Nome del file di input = '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')   
      write(log,*)'n=',n,' ampiezza=',amp
      write(log,*)'a',amp,'x',n
      do 2 i=1,amp
         do 1 j=1,n
            read(11,*)a(i,j) 
            write(log,*)a(i,j)
    1         continue
    2     continue
      close(11)
      
      write(log,*)'chiamata sub'
      call lub(a,dim,n,p,q,ifail,log)
      write(log,*)'uscita sub, ifail=',ifail
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 6) stop 'Errore! ampiezza di banda non valida'
      if (ifail .eq. 7) stop 'Errore! minore principale singolare'
       
      print*,'Nome del file di output ='
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)((a(i,j),j=1,n),i=1,amp) 
      
      write(log,*)'matrice fattorizzata'
      do i=1,amp
          write(log,*)( a(i,j),j=1,n)
      end do
                 
      close(12)                     
      close(log)
      
      print*,'Matrice fattorizzata ='
      write(*,20)((a(i,j),j=1,n),i=1,n)
        
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
   30 format (1X,I3)
   
      End
      stop                                     