      Program lutd
c     Programma dimostrativo della subroutine lut

      external lut
      
      integer dim
      parameter (dim=6)
       
      real d(dim),e(dim-1),f(dim-1)
      integer n,ifail
      character*12 fin,fout
       
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE LUT ***'
      print*
      
      write(*,10)'Ordine della matrice (max ',dim,')= '
      read(*,*)n
      
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n
         read(11,*)d(i)
    1 continue
      do 2 i=1,n-1
         read(11,*)e(i)
    2 continue
      do 3 i=1,n-1
         read(11,*)f(i)
    3 continue
      close(11)                
       
      call lut(d,e,f,n,ifail)
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 5) stop 'Errore! minore principale singolare'
       
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)(d(i),i=1,n)
      write(12,*)
      write(12,20)(e(i),i=1,n-1)
      write(12,*)
      write(12,20)(f(i),i=1,n-1)
      close(12) 
       
      print*,'Matrice fattorizzata= '
      print*,'diagonale principale= '
      write(*,20)(d(i),i=1,n)
      print*,'diagonale inferiore= '
      write(*,20)(e(i),i=1,n-1)
      print*,'diagonale superiore= '
      write(*,20)(f(i),i=1,n-1)
        
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
   
      End
	stop