      Program slupd
c     Programma dimostrativo della subroutine slup  
c     l'eseguibile attuale e' linkato con slup3.f

      external slup
      
      integer dim
      parameter (dim=6)
      parameter (log=13)
       
      real lu(dim,dim),b(dim)
      integer p(dim),n,ifail
      character*12 fin,fout
c     
c     lu matrice LU fattorizzata da lup
c     p vettore delle permutazioni
c     n ordine del sistema 
c     b vettore dei termini noti in input, vettore soluzione in output 
     
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE SLUP 04 ***'
      print*
      write(*,10)'Ordine del sistema (max ',dim,') ='
      read(*,*)n   
                                
      open(log,FILE='slup.log')
      
      print*,'Nome del file di input ='
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')  
                       
c     leggo la matrice lu dal file
      write(log,*)'leggo la matrice fattorizzata da lup da file'
      write(log,*)'la matrice letta deve essere ordinata'
      write(Log,*)'secondo il vettore pivot'
      do 2 i=1,n
         do 1 j=1,n
            read(11,*)lu(i,j) 
            write(log,*)lu(i,j)
    1    continue
    2 continue               
                                              
      write(log,*)'leggo il vettore delle permutazioni' 
c     leggo il vettore delle permutazioni dal file
      read(11,*)
      do 3 i=1,n
         read(11,*)p(i)                               
         write(log,*)p(i)
    3 continue                      
    
                        
      write(log,*)'leggo il vettore dei termini noti'
c     leggo il vettore dei termini noti dal file
      read(11,*)
      do 4 i=1,n
         read(11,*)b(i)                             
         write(log,*)b(i)
    4 continue                                   
    
      close(11)      
      
      write(log,*)'richiamo slup'
            
      call slup(lu,p,b,dim,n,ifail,log)   
      
      write(log,*)'ritorno al chiamante, ifail=',ifail
      
c     il vettore b in uscita contiene la soluzione del sistema
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
       
      write(log,*)'soluzione del sistema'
      print*,'Nome del file di output ='
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)(b(i),i=1,n)
      
      write(log,20)(b(i),i=1,n)
      
      close(12)                          
      close(log)
      
      print*,'Soluzione del sistema='
      write(*,20)(b(i),i=1,n)
      
   10 format (1X,A,I3,A)
   20 format (5X,E14.7)  
   
      end
	stop                                     