      Program sspard
c     programma dimostrativo della subroutine sspar

      external sspar                 
      
      integer dim,nnz
      parameter (dim=10, nnz=20)
                               
      integer nrc,n,c(nnz),irc(dim+1),nmax,ifail,log
      real r(nnz),b(dim),tolr,resr,x0(dim),x(dim)
      character*12 fin,fout
      
      log=13
      open(log,FILE="spm.log")
           
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE SSPAR 3 ***'
      print*
      write(*,20)'Ordine del sistema (max ',dim,')= '
      read(*,*)n
      write(*,20)'Numero di elementi non nulli (max ',nnz,')= '
      read(*,*)nrc          
      print*,'Tolleranza relativa per la soluzione= '
      read(*,*)tolr
      print*,'Residuo relativo= '
      read(*,*)resr
      print*,'Numero massimo di iterazioni= '
      read(*,*)nmax
      
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      write(log,*)'lettura dati: r, c, irc, b'
      read(11,*)
      write(log,*)'r:'
      do 1 i=1,nrc
         read(11,*)r(i)
         write(log,*)i,r(i)
    1 continue     
                      
      write(log,*)'c:'
      do 2 i=1,nrc
         read(11,*)c(i)
         write(log,*)i,c(i)
    2 continue           
    
      write(log,*)'irc:'
      do 3 i=1,n+1
         read(11,*)irc(i)
         write(log,*)i,irc(i)
    3 continue          
         
      write(log,*)'b:'
      do 4 i=1,n
         read(11,*)b(i)
         write(log,*)i,b(i) 
    4 continue
      close(11)
            
      do 10 i=1,n
         x0(i)=0
   10 continue
      
      write(log,*)'parametri passati in input n:',n
      write(log,*)'chiamata sub sspar'                   
      call sspar(r,c,irc,n,nrc,b,tolr,resr,nmax,x0,x,ifail,log)      
      
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 1) stop 'Errore! tolleranza relativa non valida'
      if (ifail .eq. 10) stop 'Errore! elemento diagonale nullo'
      if (ifail .eq. 9) print*,'Attenzione! calcolo interrotto per ',
     %             'raggiungimento del numero massimo di iterazioni'
                   
      print*,'Nome del file di output= '
      read(*,'(A)')fout        
      open(12,FILE=fout)
      write(log,*)'output, b='
      write(log,*)(x0(i),i=1,n)
      write(log,*)'ifail=',ifail
      close(log)
      
      write(12,30)(x(i),i=1,n)
      close(12)
      
      print*,'Soluzione del sistema='
      write(*,30)(x(i),i=1,n)
         
   20 format(1X,A,I3,A)
   30 format(1X,E14.7)
   
      End
      stop